import { comments } from "../templateUtils.js";

export default (data) =>
	`// this file contains a test harness that was auto-generated by fastify-openapi-glue
// running the tests directly after generation will probably fail as the parameters
// need to be manually added.

import { test } from "node:test";
import { strict as assert } from "node:assert/strict";
import Fastify from "fastify";
import fastifyPlugin from "../${data.plugin}";
import { options } from "../${data.plugin}";

const opts = {};
//${data.routes
		.map(
			(route) => `
// Operation: ${route.operationId}
// URL: ${route.url}
// summary:	${route.schema.summary}
${comments(route, 0)}
test("testing ${route.operationId}", (t) => {

	const fastify = Fastify(options);
	fastify.register(fastifyPlugin, opts);

	fastify.inject(
		{
			method: "${route.method}",
			url: "${data.generic.basePath ? data.generic.basePath : ""}${route.url}",
			payload: undefined,${
				route.schema.body ? " //insert body data here!!" : ""
			}
			headers: undefined,${
				route.schema.headers ? " //insert headers here!!" : ""
			}
		},
		(err, res) => {
	assert.ifError(err);
		assert.equal(res.statusCode, 200);
		},
	);
});`,
		)
		.join("\n")}
`;
